# Create an Earthworm environment on Solaris!
# This file should be sourced by any shell wanting 
# to run or build EARTHWORM system.

# Set environment variables describing your Earthworm directory/version
setenv EW_HOME          /home/earthworm
setenv EW_VERSION       earthworm_svn
setenv SYS_NAME         `hostname`

# Set environment variables used by earthworm modules at run-time
# Path names must end with the slash "/"
setenv EW_INSTALLATION  INST_UNKNOWN
setenv EW_PARAMS        ${EW_HOME}/run_working/params/
setenv EW_LOG           ${EW_HOME}/run_working/log/


# Tack the earthworm bin directory in front of the current path
set path=( ${EW_HOME}/${EW_VERSION}/bin /opt/oracle/bin /var/opt/oracle $path )

# Set up library path for dynamically loaded libraries:
setenv OPENWINHOME   /usr/openwin
setenv COMPILER_DIR  /opt/SUNWspro
if ("${?LD_LIBRARY_PATH}" == 0) then
	setenv LD_LIBRARY_PATH "${OPENWINHOME}/lib:${COMPILER_DIR}/lib:/usr/lib"
else
	setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${OPENWINHOME}/lib:${COMPILER_DIR}/lib:/usr/lib"
endif

# Set environment variables for compiling earthworm modules
setenv GLOBALFLAGS "-D_SPARC -D_SOLARIS -I${EW_HOME}/${EW_VERSION}/include -I${SCHEMA_DIR}/src/include -I${SCHEMA_DIR}/src/include/internal -I${APPS_DIR}/src/include -I${ORACLE_HOME}/rdbms/demo"
setenv PLATFORM "SOLARIS"
setenv LINK_LIBS "-lm"

# Create an alias for making executables
alias emake   'make -f makefile.sol'
alias make_ew 'make_ew_solaris'

# Number of available file descriptors
limit descriptors 256
